BUILD_DIR = .

ifdef IVAN_EMACS_VERSION
    EMACS_BIN = /Users/ivan/src/emacs-24.1/nextstep/Emacs.app/Contents/MacOS/Emacs
else
    EMACS_BIN = emacs
endif

EMACS_CMD = $(EMACS_BIN) --no-init-file --no-site-file -batch \
--eval "(setq load-path (cons \".\" load-path))" \
--eval "(setq load-path (cons \"..\" load-path))" \
--eval "(setq load-path (cons \"../bbdb\" load-path))" \
--eval "(setq load-path (cons \"../ivan\" load-path))" \
--eval "(setq load-path (cons \"../..\" load-path))"

AUTOLOAD = --eval "(setq load-path (cons \"..\" load-path))" \
--eval "(require 'ivan-autoload)" \
--eval "(let ((generated-autoload-file (expand-file-name \"$@\"))) \
  (mapcar (function update-file-autoloads) command-line-args-left) \
  (save-buffers-kill-emacs t))"

ifdef INSTALL_DIR
    BUILD_DIR := $(BUILD_DIR)/$(INSTALL_DIR)
endif

ELC = $(patsubst %.el,$(BUILD_DIR)/%.elc,$(SRC))

ifdef AUTO_FILE
    ELC += $(BUILD_DIR)/$(AUTO_FILE).elc
endif

all: copy-init makedir $(ELC) copy-after

copy-init:
	mkdir -p $(HOME)/.emacs.d
	if test -f init.el ; then cp init.el $(HOME)/.emacs.d ; fi

copy-after:
	if test -f org-version.el ; then cp org-version.el $(BUILD_DIR) ; fi
makedir:
	mkdir -p $(BUILD_DIR)

$(BUILD_DIR)/%.elc: %.el
	@$(EMACS_CMD) -f batch-byte-compile $<
	@mv $(subst .el,.elc,$<) $@

$(AUTO_FILE).el: $(SRC)
	@$(EMACS_CMD) $(AUTOLOAD) $(SRC)
	if test ! -f $@ ; then touch $@ ; fi
	@rm -f $(AUTO_FILE).el~

clean:
	rm -f $(ELC) $(AUTO_FILE).el $(AUTO_FILE).elc

.INTERMEDIATE: $(AUTO_FILE).el

.SILENT:
