;;; ivan-autoload.el --- hack autoload to allow byte compilation

(require 'autoload)

(defun autoload-ensure-default-file (file)
  "Make sure that the autoload file FILE exists and if not create it.
Unlike the function in emacs it allows byte compilation"
  (unless (file-exists-p file)
    (write-region
     (concat ";;; " (file-name-nondirectory file)
             " --- automatically extracted autoloads\n"
             ";;\n"
             ";;; Code:\n\n"
             "\n;; Local Variables:\n"
             ";; version-control: never\n"
             ";; no-update-autoloads: t\n"
             ";; coding: utf-8\n"
             ";; End:\n"
             ";;; " (file-name-nondirectory file)
             " ends here\n")
     nil file))
  file)

(provide 'ivan-autoload)



;; Copyright (C) 2007 Ivan Kanis
;; Author: Ivan Kanis
;; $Id: ivan-autoload.el 1843 2007-06-06 16:52:13Z ivan $
;;
;; This program is free software ; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation ; either version 2 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY ; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program ; if not, write to the Free Software
;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

;; Local Variables:
;; compile-command: "./ivan-autoload.el"
;; End:
